<%-- $Id: list_events.jsp 6604 2014-11-18 10:39:22Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioPlateEvent"
	import="net.sf.basedb.core.BioPlateEventParticipant"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.units.UnitUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOMATERIALEVENT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final Item bioMaterialType = Item.valueOf(request.getParameter("biomaterial_type"));
final int bioMaterialId = Values.getInt(request.getParameter("biomaterial_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("event", "events");
final DbControl dc = sc.newDbControl();
ItemResultIterator<BioMaterialEvent> events = null;
try
{
	final MeasuredBioMaterial bioMaterial = (MeasuredBioMaterial)bioMaterialType.getById(dc, bioMaterialId);
	final BioMaterialEvent creationEvent = bioMaterial.getCreationEvent();
	final boolean createPermission = bioMaterial.hasPermission(Permission.WRITE);
	final boolean deletePermission = createPermission;

	String viewPage = null;
	String listName = null;
	if (bioMaterialType == Item.SAMPLE)
	{
		listName = "Samples";
		viewPage = "../samples/index.jsp";
	}
	else if (bioMaterialType == Item.EXTRACT)
	{
		listName = "Extracts";
		viewPage = "../extracts/index.jsp";
	}
	
	Unit microGram = UnitUtil.getUnit(dc, Quantity.MASS, "µg");
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	try
	{
		final ItemQuery<BioMaterialEvent> query = Base.getConfiguredQuery(dc, cc, true, bioMaterial.getEvents(), mode);
		events = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Number> numericFormatter = FormatterFactory.getNumberFormatter(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioMaterial);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" type="<%=mode.getPageType()%>" id="list-page">
	<base:head scripts="table.js,tabcontrol-2.js,~events.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	
	<base:body>
		<p:path><p:pathelement 
			title="<%=listName%>" href="<%=viewPage+"?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(bioMaterial.getName())%>"
			/></p:path>

		<t:tabcontrol 
			id="main" 
			subclass="mastertabcontrol content"
			active="events">
		<t:tab id="properties" title="Properties" />
		<t:tab id="annotations" title="Annotations &amp; parameters"
			tooltip="View annotation values and protocol parameters" />
		
		<t:tab id="events" title="Events">
		<tbl:table 
			id="events" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="biomaterial_id"
				value="<%=String.valueOf(bioMaterialId)%>" 
			/>
			<tbl:hidden 
				name="biomaterial_type" 
				value="<%=bioMaterialType.name()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<%
			Enumeration<String, String> eventTypes = new Enumeration<String, String>();
			for (BioMaterialEvent.Type et : BioMaterialEvent.Type.values())
			{
				eventTypes.add(Integer.toString(et.getValue()), HTML.encodeTags(et.toString()));
			}
			%>
			<tbl:columndef 
				id="type"
				property="eventType"
				datatype="int"
				title="Type"
				enumeration="<%=eventTypes%>"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="entryDate"
				property="entryDate"
				datatype="date"
				title="Entry date"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="eventDate"
				property="eventDate"
				datatype="date"
				title="Event date"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="quantity"
				datatype="float"
				title="Used quantity (µg)"
				sortable="false" 
				filterable="false"
				exportable="false"
				unit="<%=microGram%>"
				formatter="<%=numericFormatter %>"
			/>
			<tbl:columndef
				id="bioPlateEvent"
				property="bioPlateEventParticipant.event.name"
				datatype="string"
				title="Plate event"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="protocol"
				property="protocol.name"
				datatype="string"
				title="Protocol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="user"
				property="user.name"
				datatype="string"
				title="User"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="comment"
				property="comment"
				datatype="string"
				title="Comment" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar
					visible="<%=mode.hasToolbar()%>"
					subclass="bottomborder"
					>
					<tbl:button 
						id="btnNewItem"
						data-extra-url="<%="&biomaterial_type="+bioMaterialType.name()+"&biomaterial_id="+bioMaterialId%>"
						disabled="<%=!createPermission%>" 
						image="new.png" 
						title="New&hellip;" 
						tooltip="<%=createPermission ? "Create new event" : "You do not have permission to create events"%>" 
					/>
					<tbl:button 
						id="btnDeleteItems"
						disabled="<%=!deletePermission%>" 
						image="delete.png" 
						title="Delete&hellip;"
						data-confirm="1"
						tooltip="<%=deletePermission ? "Delete the selected events" : "You do not have permission to delete events"%>" 
					/>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button 
						id="btnImport"
						data-plugin-type="IMPORT"
						image="import.png" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						id="btnExport"
						data-plugin-type="EXPORT"
						image="export.png" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						id="btnRunPlugin"
						data-plugin-type="OTHER"
						image="runplugin.png" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=events == null ? 0 : events.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasCheck()%>"
							><base:icon 
								id="check.uncheck"
								image="check_uncheck.png" 
								tooltip="Check/uncheck all" 
								 
							/></tbl:header>
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasRadio()%>"
							/>
						<tbl:header 
							subclass="icons" 
							visible="<%=mode.hasIcons()%>"
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (events != null)
					{
						while (events.hasNext())
						{
							BioMaterialEvent item = events.next();
							BioMaterialEvent.Type eventType = item.getEventType();
							int itemId = item.getId();
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ? 
								"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							String name = "TODO";
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="TODO" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
											type="radio" 
											name="item_id" 
											value="<%=itemId%>" 
											title="<%=name%>" 
											<%=selectedItemId == itemId ? "checked" : ""%>
										></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									>&nbsp;</tbl:header>
								<tbl:cell column="type">
									<%
									if (eventType == BioMaterialEvent.Type.OTHER)
									{
										%>
										<div
											class="link table-item"
											data-item-id="<%=itemId%>"
											data-no-edit="<%=writePermission ? 0 : 1 %>" 
											data-extra-url="&biomaterial_type=<%=bioMaterialType.name()%>&biomaterial_id=<%=bioMaterialId%>"
											tabindex="0"
											title="<%=tooltip%>"><%=eventType%></div>
										<%
									}
									else if (eventType == BioMaterialEvent.Type.CREATION)
									{
										if (item.equals(creationEvent))
										{
											%>
											<div
												class="link table-item"
												data-item-id="<%=itemId%>"
												data-no-edit="1" 
												data-extra-url="&biomaterial_type=<%=bioMaterialType.name()%>&biomaterial_id=<%=bioMaterialId%>"
												tabindex="0"
												title="View this item">Created</div>
											<%
										}
										else
										{
											MeasuredBioMaterial child = null;
											try
											{
												child = item.getBioMaterial();
											}
											catch (PermissionDeniedException ex)
											{}
											%>
											<div
												class="link table-item"
												data-item-id="<%=itemId%>"
												data-no-edit="1" 
												data-extra-url="&biomaterial_type=<%=bioMaterialType.name()%>&biomaterial_id=<%=bioMaterialId%>"
												tabindex="0"
												title="View this item">
												Created <%=child == null ? "child" : child.getType().toString().toLowerCase() %>: <base:propertyvalue 
														item="<%=item%>" 
														property="bioMaterial"
														enableEditLink="<%=false%>" 
														enablePropertyLink="<%=false%>"
													/>
												</div>
											<%
										}
									}
									else if (eventType == BioMaterialEvent.Type.BIOASSAY)
									{
										%>
										<div
											class="link table-item"
											data-item-id="<%=itemId%>"
											data-no-edit="1" 
											data-extra-url="&biomaterial_type=<%=bioMaterialType.name()%>&biomaterial_id=<%=bioMaterialId%>"
											tabindex="0"
											title="View this item">
												Bioassay: <base:propertyvalue 
														item="<%=item%>" 
														property="physicalBioAssay"
														enableEditLink="<%=false%>" 
														enablePropertyLink="<%=false%>"
													/>
										</div>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="eventDate" value="<%=item.getEventDate()%>" />
								<tbl:cell column="entryDate" value="<%=item.getEntryDate()%>" />
								<tbl:cell column="quantity" value="<%=item.getUsedQuantity(bioMaterial)%>" />
								<tbl:cell column="bioPlateEvent">
									<%
									try
									{
										BioPlateEventParticipant participant = item.getBioPlateEventParticipant();
										if (participant != null)
										{
											BioPlateEvent event = participant.getEvent();
											String extraUrl = "";
											try
											{
												extraUrl = "&bioplate_id=" + participant.getBioPlate().getId();
											}
											catch (PermissionDeniedException ex)
											{}
											boolean editLink = event.hasPermission(Permission.WRITE);
											if (mode.hasPropertyLink())
											{
												%>
												<span class="link auto-init"
													data-auto-init="item-link" 
													data-item-type="BIOPLATEEVENT"
													data-item-id="<%=event.getId()%>"
													data-no-edit="<%=editLink ? 0 : 1 %>"
													data-extra-url="<%=extraUrl %>"
													title="View this bioplate event <%=editLink? "(use CTRL, ALT or SHIFT to edit)" : ""%>"
												>
												<%=HTML.encodeTags(event.getName()) %>
												</span>
												<%
											}
											else
											{
												%>
												<%=HTML.encodeTags(event.getName()) %>
												<%
											}
										}
										else
										{
											%>
											<i>- none -</i>
											<%
										}
									}
									catch (PermissionDeniedException ex)
									{
										%>
										<i>- denied -</i>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="protocol"
									><base:propertyvalue 
										item="<%=item%>" 
										property="protocol"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="user"
									><base:propertyvalue 
										item="<%=item%>" 
										property="user"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="comment"><%=HTML.encodeTags(item.getComment())%></tbl:cell>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
						}
					}
					if (numListed == 0)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer note">
							<%=events == null || events.getTotalCount() == 0 ? "No events were found" : "No events on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
		</tbl:table>
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button id="close" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button id="close" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		</t:tab>
		
		<t:tab id="overview" title="Overview" 
			tooltip="Display a tree overview of related items" />
		<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>" />
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (events != null) events.close();
	if (dc != null) dc.close();
}
%>
