/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Members = function()
{
	var members = {};
	
	/**
		Initialize the page.
	*/
	members.initPage = function()
	{
		var attributes = {'item-type': Data.get('page-data', 'item-type')};
		var tableAttributes = {'table-id': 'members'};
		Buttons.addClickHandler('btnDeleteItems', Buttons.deleteItems, tableAttributes);
		Buttons.addClickHandler('btnRestoreItems', Buttons.restoreItems, tableAttributes);
		Buttons.addClickHandler('btnShareItems', Buttons.shareItems, tableAttributes);
		Buttons.addClickHandler('btnSetOwner', Buttons.setOwnerOfItems, tableAttributes);
		Buttons.addClickHandler('btnColumns', Buttons.configureColumns, tableAttributes);
		Buttons.addClickHandler('btnExport', Buttons.runListPlugin, tableAttributes);
		Buttons.addClickHandler('btnImport', Buttons.runListPlugin, tableAttributes);
		Buttons.addClickHandler('btnRunPlugin', Buttons.runListPlugin, tableAttributes);
		Buttons.addClickHandler('btnAddMembers', members.addMembersOnClick, tableAttributes);
		Buttons.addClickHandler('btnRemoveMembers', members.removeMembersOnClick, tableAttributes);
		Buttons.addClickHandler('btnPlaceOnPlate', members.placeOnPlateOnClick);

		TabControl.setSwitchFunction('main', members.switchTab);
		
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnOk', Buttons.returnSelected, tableAttributes);
	}
	
	
	members.addMembersOnClick = function()
	{
		var frm = document.forms['members'];
		var url = 'add_members_frameset.jsp?ID='+App.getSessionId();
		url += '&list_id='+frm.list_id.value;
		Dialogs.openPopup(url, 'AddMembers', 1050, 700);
	}
	
	members.removeMembersOnClick = function()
	{
		var numSelected = Table.checkIfSelected('members');
		if (numSelected == 0) return;
		
		if (!confirm('You are about to remove '+numSelected+' item(s) from the list. Continue?'))
		{
			return;
		}
		var frm = document.forms['members'];
		frm.cmd.value = 'RemoveMembers';
		frm.submit();
	}

	members.placeOnPlateOnClick = function()
	{
		Table.submitToPopup('members', 'PlaceOnPlate', 900, 600);
	}
	
	members.switchTab = function(event)
	{
		var target = event.target;
		var tabId = target.id.substring(5);

		var frm = document.forms['members'];
		var url = '../index.jsp?ID='+App.getSessionId();
		url += '&cmd=ViewItem&item_id='+frm.list_id.value;;
		url += '&tab='+tabId;
		location.replace(url);
	}
	
	
	
	return members;
}();

Doc.onLoad(Members.initPage);
